/**
 * Program skeleton for the course "Programming embedded systems"
 */

#include <stdio.h>

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "stm32f10x_conf.h"
#include "task.h"
#include "setup.h"

/*-----------------------------------------------------------*/

void myTask(void *params) {
  char *str = (char*)params;
  for (;;) {
    printf("%s\n", str);
	vTaskDelay(100 / portTICK_RATE_MS);
  }
  assert(0);
}

static char *str1 = "I'm running!";
static char *str2 = "Me too!";

/*
 * Entry point of program execution
 */
int main( void )
{
  prvSetupHardware();

  xTaskCreate(myTask,   // pointer to task function
              "myTask",	// name of task
			  100,      // size of stack: 100 words = 400 byte
			            // should be at least configMINIMAL_STACK_SIZE
			  str1,     // task parameters
			  1,        // priority: number between
			            // 0 and (configMAX_PRIORITIES - 1)
			  NULL      // handle to the task
			  );

  xTaskCreate(myTask,   // pointer to task function
              "myTask2",	// name of task
			  100,      // size of stack: 100 words = 400 byte
			            // should be at least configMINIMAL_STACK_SIZE
			  str2,     // task parameters
			  2,        // priority: number between
			            // 0 and (configMAX_PRIORITIES - 1)
			  NULL      // handle to the task
			  );

  vTaskStartScheduler();
  assert(0);
  return 0;                 // not reachable
}
/*-----------------------------------------------------------*/


